# Generated by Django 2.2.14 on 2020-07-21 23:10

from django.db import migrations, models
import django.db.models.deletion
import polymorphic_fk.fields
import polymorphic_fk.tests.test_admin.models


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        ('contenttypes', '0002_remove_content_type_name'),
    ]

    operations = [
        migrations.CreateModel(
            name='Base',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('slug', models.SlugField()),
                ('polymorphic_ctype', models.ForeignKey(editable=False, null=True, on_delete=django.db.models.deletion.CASCADE, related_name='polymorphic_test_admin.base_set+', to='contenttypes.ContentType')),
            ],
            options={
                'abstract': False,
                'base_manager_name': 'objects',
            },
            bases=(polymorphic_fk.tests.test_admin.models.AdminLinkMixin, models.Model),
        ),
        migrations.CreateModel(
            name='Group',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('slug', models.SlugField()),
            ],
            bases=(polymorphic_fk.tests.test_admin.models.AdminLinkMixin, models.Model),
        ),
        migrations.CreateModel(
            name='A',
            fields=[
                ('base_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='test_admin.Base')),
                ('a_val', models.CharField(max_length=32)),
            ],
            options={
                'abstract': False,
                'base_manager_name': 'objects',
            },
            bases=('test_admin.base',),
        ),
        migrations.CreateModel(
            name='B',
            fields=[
                ('base_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='test_admin.Base')),
                ('b_val', models.CharField(max_length=32)),
            ],
            options={
                'abstract': False,
                'base_manager_name': 'objects',
            },
            bases=('test_admin.base',),
        ),
        migrations.CreateModel(
            name='C',
            fields=[
                ('base_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='test_admin.Base')),
                ('c_val', models.CharField(max_length=32)),
            ],
            options={
                'abstract': False,
                'base_manager_name': 'objects',
            },
            bases=('test_admin.base',),
        ),
        migrations.CreateModel(
            name='Item',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('slug', models.SlugField()),
                ('position', models.PositiveIntegerField(default=0)),
                ('fk', polymorphic_fk.fields.PolymorphicForeignKey(on_delete=django.db.models.deletion.CASCADE, to='test_admin.Base')),
                ('group', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.CASCADE, to='test_admin.Group')),
            ],
            options={
                'ordering': ['position'],
            },
            bases=(polymorphic_fk.tests.test_admin.models.AdminLinkMixin, models.Model),
        ),
    ]
